<head>
	{{ omfHeaders }}
	<script src="{{pathPrefix}}/static/sorttable.js"></script>
	<style>
	<!-- /*Styles here*/ -->
		table {
			border-collapse: collapse;
			width: 100%;
		}
		table, th, td {
			border: 1px solid black;
			text-align: center;
			padding-top: 10px;
			padding-bottom: 10px;
		}
		table.sortable th:not(.sorttable_sorted):not(.sorttable_sorted_reverse):not(.sorttable_nosort):after {
		    content: " \25B4\25BE" 	
		 }
		th {
			background-color: #8c8c8c;
		}
		tr:nth-child(even) {
			background-color: #e6e6e6;
		}
	</style>
	<script src="{{pathPrefix}}/static/highcharts4.src.js"></script>
	<script src="https://cdn.plot.ly/plotly-1.50.1.min.js"></script>
	<!-- Leaflet -->
	<link rel="stylesheet" href="https://unpkg.com/leaflet@1.5.1/dist/leaflet.css"	integrity="sha512-xwE/Az9zrjBIphAcBb3F6JVqxf46+CDLwfLMHloNu6KEQCAWi6HcDUbeOfBIptF7tcCzusKFjFw2yuvEpDL9wQ=="	crossorigin=""/>
	<script src="https://unpkg.com/leaflet@1.5.1/dist/leaflet.js" integrity="sha512-GffPMF3RvMeYyc1LWMHtK8EbPv0iNZ8/oTtHPx9/cc2ILxQ+u905qIwdpULaqDkyBKgOaB57QTMg7ztg8Jm2Og==" crossorigin=""></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/noUiSlider/8.5.1/nouislider.min.css" />
	<script src="https://cdnjs.cloudflare.com/ajax/libs/noUiSlider/8.5.1/nouislider.min.js"></script>
	<style>#map{
		position: relative;
		width: 100.0%;
		height: 100.0%;
		left: 0.0%;
		top: 0.0%;
		}
	</style>
</head>
<body>
	{{ omfModelTitle }}
	<p class="reportTitle">Model Input</p>
	<div id="input" class="content">
		<form name="inputForm" action="/runModel/" onsubmit="event.preventDefault(); return isFormValid();" method="post">
			<div class="shortInput">
				<label>Model Type <a href="https://github.com/dpinney/omf/wiki/Models-~-microgridControl" target="blank">Help?</a></label>
				<input type="text" id="modelType" name="modelType" value="{{allInputDataDict.modelType}}" value="{{modelName}}" readonly/>
			</div>
			<div class="shortInput">
				<label>Model Name</label>
				<input type="text" id="modelName" name="modelName" value="{{allInputDataDict.modelName}}" pattern="^[\w\s\d\.-]+$" required="required">
			</div>
			<div class="shortInput">
				<label>User</label>
				<input type="text" id="user" name="user" value="{{allInputDataDict.user}}" readonly/>
			</div>
			<div class="shortInput ">
				<label>Created</label>
				<input type="text" id="created" name="created" value="{{allInputDataDict.created}}" readonly/>
			</div>
			<div class="shortInput">
				<label>Run Time</label>
				<input type="text" id="runTime" name="runTime" value="{{allInputDataDict.runTime}}" readonly/>
			</div>
			<div class="wideInput">
				<p class="inputSectionHeader">Model Specifications</p>
			</div>
			<hr>
			<div class="shortInput">
				<label>Feeder</label>
				<script type="text/javascript">
				function editFeeder(modelName, feederNum) {
					console.log("modelName:",modelName)
					studyUser = allInputData.user
					window.open("/feeder/" + studyUser + "/" + modelName + "/" + feederNum,  "_blank")
				}
				</script>
				<button id="feederButton" type="button" onclick="javascript:editFeeder(allInputData.modelName,1);" style="display:block;width:125px;">Open Editor</button>
				<input type="text" id="feederName1" name="feederName1" value="{{allInputDataDict.feederName1}}" style="display:none">
			</div>
			<div class="shortInput">
				<label class="tooltip">Event Information (.json file)<span class="classic">Please see the documentation at the help link for the required format</span></label>
				<input id="eventFile" type="file" style="display:none" onchange="handle_files(this.files,'eventData','eventFileName')">
				<input id="eventData" name="eventData" value='{{allInputDataDict.eventData}}' type="hidden">
				<div>
					<label for="eventFile" class="fileButton">Choose File</label>
					<input id="eventFileName" name="eventFileName" value="{{allInputDataDict.eventFileName}}" value='' readonly class="uploadFileName">
				</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Solution Fidelity<span class="classic">Select an option for the level of fidelity of the results.</span></label>
				<select id="solFidelity" name="solFidelity" value="{{allInputDataDict.solFidelity}}" />
					<option value='0.10' {% if allInputDataDict.solFidelity == '0.10%' %}selected{% endif %}>Low</option>
					<option value='0.05' {% if allInputDataDict.solFidelity == '0.05%' %}selected{% endif %}>Medium</option>
					<option value='0.02' {% if allInputDataDict.solFidelity == '0.02%' %}selected{% endif %}>High</option>
				</select>
			</div>
			<div class="shortInput">
				<label class="tooltip">Generate Default Settings?<span class="classic">If yes, a default settings file will be generated; if no, the user must upload a settings file.</span></label>
				<select id="genSettings" name="genSettings" value="{{allInputDataDict.genSettings}}" />
					<option value='True' {% if allInputDataDict.genSettings == 'True' %}selected{% endif %}>Yes</option>
					<option value='False' {% if allInputDataDict.genSettings == 'False' %}selected{% endif %}>No</option>
				</select>
			</div>
			<div class="shortInput">
				<label class="tooltip">Settings (.json file)<span class="classic">Please see the documentation at the help link for the required format. You can also select "Yes" for the "Generate Default Settings?" field to run using a generated default settings file.</span></label>
				<input id="settingsFile" type="file" style="display:none" onchange="handle_files(this.files,'settingsData','settingsFileName')">
				<input id="settingsData" name="settingsData" value='{{allInputDataDict.settingsData}}' type="hidden">
				<div>
					<label for="settingsFile" class="fileButton">Choose File</label>
					<input id="settingsFileName" name="settingsFileName" value="{{allInputDataDict.settingsFileName}}" value='' readonly class="uploadFileName">
				</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Load Priorities (.json file)<span class="classic">Please see the documentation at the help link for the required format of custom load priority file input.</span></label>
				<input id="loadPriorityFile" type="file" style="display:none" onchange="handle_files(this.files,'loadPriorityData','loadPriorityFileName')">
				<input id="loadPriorityData" name="loadPriorityData" value='{{allInputDataDict.loadPriorityData}}' type="hidden">
				<div>
					<label for="loadPriorityFile" class="fileButton">Choose File</label>
					<input id="loadPriorityFileName" name="loadPriorityFileName" value="{{allInputDataDict.loadPriorityFileName}}" value='' readonly class="uploadFileName">
				</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Cached Output?<span class="classic">If yes, use the Cached Output provided; if no, use the events.json to run the feeder system through ONM.</span></label>
				<select id="useCache" name="useCache" value="{{allInputDataDict.useCache}}" />
					<option value='True' {% if allInputDataDict.useCache == 'True' %}selected{% endif %}>Yes</option>
					<option value='False' {% if allInputDataDict.useCache == 'False' %}selected{% endif %}>No</option>
				</select>
			</div>
			<div class="shortInput">
				<label class="tooltip">Cached Output (.json file)<span class="classic">Please see the documentation at the help link for the required format</span></label>
				<input id="outputFile" type="file" style="display:none" onchange="handle_files(this.files,'outputData','outputFileName')">
				<input id="outputData" name="outputData" value='{{allInputDataDict.outputData}}' type="hidden">
				<div>
					<label for="outputFile" class="fileButton">Choose File</label>
					<input id="outputFileName" name="outputFileName" value="{{allInputDataDict.outputFileName}}" value='' readonly class="uploadFileName">
				</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Microgrid Tagging (.csv file)<span class="classic">Please see the documentation at the help link for the required format custom microgrid tagging file input.</span></label>
				<input id="microgridTaggingFile" type="file" style="display:none" onchange="handle_files(this.files,'microgridTaggingData','microgridTaggingFileName')">
				<input id="microgridTaggingData" name="microgridTaggingData" value='{{allInputDataDict.microgridTaggingData}}' type="hidden">
				<div>
					<label for="microgridTaggingFile" class="fileButton">Choose File</label>
					<input id="microgridTaggingFileName" name="microgridTaggingFileName" value="{{allInputDataDict.microgridTaggingFileName}}" value='' readonly class="uploadFileName">
				</div>
			</div>
			<div class="wideInput">
				<p class="inputSectionHeader">Outage Cost Parameters</p>
			</div>
			<hr>
			<div class="shortInput">
				<label class="tooltip">Customer Information (.csv file)<span class="classic">Please see the documentation at the help link for the required format</span></label>
				<input id="customerFile" type="file" style="display:none" onchange="handle_files(this.files,'customerData','customerFileName')">
				<input id="customerData" name="customerData" value='{{allInputDataDict.customerData}}' type="hidden">
				<div>
					<label for="customerFile" class="fileButton">Choose File</label>
					<input id="customerFileName" name="customerFileName" value="{{allInputDataDict.customerFileName}}" value='' readonly class="uploadFileName">
				</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Restoration Cost ($/hr)<span class="classic">Restoration cost parameter for calculating outage costs.</span></label>
				<input type="text" id="restoration_cost" name="restoration_cost" value="{{allInputDataDict.restoration_cost}}" pattern="^\d+\.?\d*$" required="required">
			</div>
			<div class="shortInput">
				<label class="tooltip">Hardware Cost ($)<span class="classic">Hardware cost parameter for calculating outage costs.</span></label>
				<input type="text" id="hardware_cost" name="hardware_cost" value="{{allInputDataDict.hardware_cost}}" pattern="^\d+\.?\d*$" required="required">
			</div>
			<div class="shortInput">
				<label class="tooltip">Energy Sales Margin<span class="classic">Decimal representing the percentage of profit on energy sales.</span></label>
				<input type="text" id="profit_on_energy_sales" name="profit_on_energy_sales" value="{{allInputDataDict.profit_on_energy_sales}}" pattern="^\d{1,3}(\.\d*?)?$" required="required">
			</div>
			{{ omfModelButtons }}
		</form>
	</div>
	{{ omfRunDebugBlock }}
	{% if modelStatus == 'finished' %}
	<div id="output">
		<p class="reportTitle">Generator Profiles</p>
		<div id="fig1" class="tightContent">
			<div id="fig1Chart" style="width:1000px"></div>
			<script type="text/javascript">
				Plotly.newPlot("fig1Chart", JSON.parse(allOutputData["fig1Data"]), JSON.parse(allOutputData["fig1Layout"]) || {})
			</script>
		</div>
		<p class="reportTitle">Voltages</p>
		<div id="fig2" class="tightContent">
			<div id="fig2Chart" style="width:1000px"></div>
			<script type="text/javascript">
				Plotly.newPlot("fig2Chart", JSON.parse(allOutputData["fig2Data"]), JSON.parse(allOutputData["fig2Layout"]) || {})
			</script>
		</div>
		<p class="reportTitle">Loads Served</p>
		<div id="fig3" class="tightContent">
			<div id="fig3Chart" style="width:1000px"></div>
			<script type="text/javascript">
				Plotly.newPlot("fig3Chart", JSON.parse(allOutputData["fig3Data"]), JSON.parse(allOutputData["fig3Layout"]) || {})
			</script>
		</div>
		<p class="reportTitle">Customer Outage Plots (wrt duration)</p>
		<div id="fig4" class="tightContent">
			<div id="fig4Chart" style="width:1000px"></div>
			<script type="text/javascript">
				Plotly.newPlot("fig4Chart", JSON.parse(allOutputData["fig4Data"]), JSON.parse(allOutputData["fig4Layout"]) || {})
			</script>
		</div>
		<p class="reportTitle" style="page-break-before:always">Customer Outage Cost</p>
		<div id="customerOutageCostCalc" class="tightContent" style="max-height:500px; overflow-y:scroll">
			{{ allOutputDataDict['customerOutageHtml'] }}
		</div>
		<p class="reportTitle">Customer Outage Histogram</p>
		<div id="fig5" class="tightContent">
			<div id="fig5Chart" style="width:1000px"></div>
			<script type="text/javascript">
				Plotly.newPlot("fig5Chart", JSON.parse(allOutputData["fig5Data"]), JSON.parse(allOutputData["fig5Layout"]) || {})
			</script>
		</div>
		<p class="reportTitle" style="page-break-before:always">Utility Outage Cost</p>
		<div id="utilityOutageCostCalc" class="tightContent">
			{{ allOutputDataDict['utilityOutageHtml'] }}
		</div>
		<p class="reportTitle"><label class="tooltip">Outage Incidence <span class="classic">The "Before" status of loads at each timestep as seen in the Timeline below is used to calculate Outage Incidence. The final timestep represents values using the "After" status for the last time in the Timeline. E.g. The Load Outage % value at Before Hour X=5 is the % of loads experiencing an outage calculated with the "Before" value of each load in the Timeline at Time 5. </span></label></p>
		<div id="fig6" class="tightContent">
			<div id="fig6Chart" style="width:1000px"></div>
			<script type="text/javascript">
				Plotly.newPlot("fig6Chart", JSON.parse(allOutputData["fig6Data"]), JSON.parse(allOutputData["fig6Layout"]) || {})
			</script>
		</div>
		<p class="reportTitle" style="page-break-before:always">Timeline</p>
		<div id="outageCostCalc" class="tightContent sorttable" style="max-height:500px; overflow-y:scroll">
			{{ allOutputDataDict['timelineStatsHtml'] }}
		</div>
		<!-- Leaflet map directly inline with model-->
		<p class="reportTitle">Outage Map and Time Slider</p>
		<div class="tightContent" style="margin-bottom:-1px">
			<div style="display: inline-block; width: inherit;">
				<div style="display: inline-block; width: 8%; margin-top: 5px; margin-bottom: 5px; margin-right: 2%; float: left">
					<input type="number" min='1' max='23' id="input-number-min" style="width: 100%; background-color:white">
				</div>
				<div id="slider" style="display: inline-block; top: 0px; right: 1px; margin: 10px 0px; width: 80%;"></div>
				<div style="display: inline-block; width: 8%; margin-top: 5px; margin-bottom: 5px; margin-left: 2%; float: right">
					<input type="number" min='2' max='24' id="input-number-max" style="width: 100%; background-color:white">
				</div>
			</div>
		</div>
		<div id="mapInsert" style="width: 1000px; margin-left: auto; margin-right: auto;"></div>
		<script type="text/javascript">
		//Hack to stop leaflet from loading before geojson data loads 
		if(modelStatus === "finished"){
		mapHtml = '<div id="map"></div>';
		gebi('mapInsert').innerHTML = mapHtml;
		//Parse geojson dict (instead of reading from geojson.js - doesn't really matter if you want to load from geojson.js, was just quicker to prototype) 
		var geojson = JSON.parse(allOutputData['geoDict']);
		console.log(geojson);

		function onEachFeature(feature, layer) {
			var popup = '';
			if (feature.properties['popupContent']) {
				//popup += feature.properties['name']
				popup += feature.properties['popupContent'];
				layer.bindPopup(popup);
			}
		}

		function pointToLayerNode(feature, latlng) {
			let fillColorValue = 'gray';
			let rad = 3;
			return L.circleMarker(latlng, {
				radius: rad,
				fillColor: fillColorValue,
				color: "#000",
				weight: 1,
				opacity: 1,
				fillOpacity: 1,//0.8
			});
		}

		function pointToEvent(feature, latlng) {
			if (feature.properties['pointColor']){
				let fillColorValue = feature.properties['pointColor'];
				let rad = 6;
			
				return L.circleMarker(latlng, {
					radius: rad,
					fillColor: fillColorValue,
					color: "#000",
					weight: 1,
					opacity: 1,
					fillOpacity: 1,//0.8,
					time: feature.properties['time'],
					tempFillColor: fillColorValue
				});
			}
		}

		function lineStyle(feature){
			if (feature.geometry['type'] == 'LineString'){
				if (feature.properties.edgeColor){
					return {
						"color": feature.properties.edgeColor,
						"time": feature.properties.time,
						"colorTemp": feature.properties.edgeColor
					}
				}
				else{
					return {
						"color": "black"
					}
				}
			}
			else if (feature.geometry['type'] == 'Polygon'){
				return {
					"color": "blue"
				}
			}
		}

		geojsonLayer = L.geoJSON(false, {
					pointToLayer: pointToLayerNode,
					onEachFeature: onEachFeature,
				});
		eventLayer = L.geoJSON(false, {
					pointToLayer:
						pointToEvent,
					onEachFeature:
						onEachFeature,
					style: lineStyle
				});

		geojson.features.forEach(function(feature){
			if (feature.geometry['type'] == 'Point'){
				geojsonLayer.addData(feature);
				eventLayer.addData(
					feature);
			}
			else if (feature.geometry['type'] == 'LineString'){
				eventLayer.addData(
					feature);
			}
			else if (feature.geometry['type'] == 'Polygon'){
				geojsonLayer.addData(feature);
			}

		});

		var bounds = geojsonLayer.getBounds();
		// var map = L.map('map').fitBounds(bounds);
		var map = L.map('map', { renderer: L.canvas() }).fitBounds(bounds);
		
		mapLink = '<a href="http://openstreetmap.org">OpenStreetMap</a>';
		L.tileLayer(
			'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
			attribution: '&copy; ' + mapLink + ' Contributors',
			maxZoom: 18,
			}).addTo(map);
		L.control.scale().addTo(map);
		geojsonLayer.addTo(map);
		eventLayer.addTo(map);
		
		// var stepSizeVal = parseFloat(allInputData.stepSize)
		var stepSizeVal = parseFloat(allOutputData['stepSize']) //This should be the value of the stepsize
		// var maxTimeVal = parseFloat(allInputData.maxTime)
		var maxTimeVal = parseFloat(allOutputData['numTimeSteps']) //This should be the value of the runtime
		document.getElementById('input-number-min').setAttribute("min", 0);
		document.getElementById('input-number-min').setAttribute("max", maxTimeVal-stepSizeVal*2);
		document.getElementById('input-number-max').setAttribute("min", stepSizeVal);
		document.getElementById('input-number-max').setAttribute("max", maxTimeVal-stepSizeVal);
		// var runtimeVal = allInputData.runTime
		var numSteps = maxTimeVal/stepSizeVal
		var slidervar = document.getElementById('slider');
		noUiSlider.create(slidervar, {
			connect: true,
			step: stepSizeVal,
			start: [ 0, maxTimeVal-stepSizeVal ],
			range: {
				min: 0,
				max: maxTimeVal-stepSizeVal
			}
		});
		// document.getElementById('input-number-min').setAttribute("value", 1);
		// document.getElementById('input-number-max').setAttribute("value", 24);
		document.getElementById('input-number-min').setAttribute("value", 0);
		document.getElementById('input-number-max').setAttribute("value", maxTimeVal-stepSizeVal);

		var inputNumberMin = document.getElementById('input-number-min');
		var inputNumberMax = document.getElementById('input-number-max');
		inputNumberMin.addEventListener('change', function(){
			slidervar.noUiSlider.set([this.value, null]);
		});
		inputNumberMax.addEventListener('change', function(){
			slidervar.noUiSlider.set([null, this.value]);
		});

		slidervar.noUiSlider.on('update', function( values, handle ) {
			//handle = 0 if min-slider is moved and handle = 1 if max slider is moved
			if (handle==0){
				document.getElementById('input-number-min').value = values[0];
			} else {
				document.getElementById('input-number-max').value =  values[1];
			}
			rangeMin = document.getElementById('input-number-min').value;
			rangeMax = document.getElementById('input-number-max').value;
			eventLayer.eachLayer(function(layer){
				if (((parseInt(layer.options.time) <= rangeMax) && (parseInt(layer.options.time) >= rangeMin)) || layer.options.colorTemp == 'red'){
					layer.setStyle({
						radius: 6,
						fillColor: layer.options.tempFillColor,
						"color": layer.options.colorTemp
					});
					layer.bringToFront()
				}
				else{
					layer.setStyle({
						radius: 1,
						fillColor: 'black',
						"color": 'black'
					});
					layer.bringToBack()
				}
			});
		})
	}
	</script>
	{{ rawOutputFiles }}
	</div>
	{% endif %}
</body>